//****************************************************************************
// File:
//
//     aboutbox.cpp    
//
// Purpose:
//
//     Implementation file for the CAboutDlg class.
//
// Functions:
//
//     CAboutDlg::OnInitDialog - Handles the "About" dialog box
//                                 initialization.
//
//
// Development Team:
//
//     Joel Krist
//
// Written by Microsoft Product Support Services, Languages Developer Support
// Copyright (c) 1993 Microsoft Corporation. All rights reserved.
//****************************************************************************

#include "stdafx.h"
#include "aboutbox.h"
#include "mainwnd.h"

// pMainWnd is initialized in CSortdemoApp::InitInstance in sortdemo.cpp
extern CMainWindow * pMainWnd;

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

//***********************************************************************
// Function:
//
//     CAboutDlg::OnInitDialog()
//
// Purpose:
//
//     Handles the initialization of the About box by centering the
//     dialog box over the main application window.
//
// Parameters:
//
//     None.
//
// Returns:
//
//     A BOOL representing that we have not set the input focus to one
//     of the controls in the dialog box.
//
// History:
//
//   Date   Comment                                           Initials
// ======== ================================================= ========
// 10/12/93 Created                                             JKK
//***********************************************************************

BOOL CAboutDlg::OnInitDialog()
{
    CDialog::OnInitDialog();
    
    // Center the dialog over the main window
    CenterWindow( pMainWnd );
    
    return TRUE;
}
