// Structures for holding a devices configuration registers

typedef struct _MEM_DSCR
{
	BYTE nHiBase;
	BYTE nLoBase;
	BYTE nControl;
	BYTE nHiRange;
	BYTE nLoRange;
} MEM_DSCR;

typedef struct _IO_DSCR
{
	BYTE nHiIOBase;
	BYTE nLoIOBase;
} IO_DSCR;

typedef struct _IRQ_DSCR
{
	BYTE nIRQLevel;
	BYTE nIRQType;
} IRQ_DSCR;

typedef struct _DMA_DSCR
{
	BYTE nDMAMask;
} DMA_DSCR;

typedef struct _DEVICE_CFG
{
	MEM_DSCR	MemConfig[NUM_MEMORY_DESC];
	IO_DSCR	IOConfig[NUM_IO_DESC];
	IRQ_DSCR	IRQConfig[NUM_IRQ_DESC];
	DMA_DSCR	DMAConfig[NUM_DMA_DESC];
} DEVICE_CFG;

