/*  cprints.h - declares cprints, a function that provides direct output
**		the video buffer in a PC.
**
**  cprints was designed to perform realtime screen output of printf formatted
**  data. It is called just like printf, with the addition of two integer
**  parameters before the format string. These integers, r and c, are the
**  row and column, respectively, from the upper-left corner of the screen
**  where output should begin, relative to zero. Since cprints uses _vsnprintf,
**  it is undesirable to invoke it from an interrupt routine when it has
**  already been invoked elsewhere. Therefore, in_cprints provides an
**  indication that cprints is active, and cprints_collisions provides a count
**  of these occurrances for error logging, etc. Use at your own risk!
**
**  Copyright 1993, Reinhold J. Gerharz
*/

#ifdef __cplusplus
extern "C" {
#endif

extern unsigned int in_cprints;		  /* non-zero when cprints is active */
extern unsigned long cprints_collisions;  /* counts simultaneous invokations */
extern unsigned int cprints_attribute;	  /* allow changing video attributes */

int cprints( int r, int c, char *fmt, ... );
void __fastcall crtputs( int r, int c, char *p);

#ifdef __cplusplus
    }
#endif
