// The file includes all the examples given in the DATE_MAN.DOC reference manual.
// All it should do is print today's date, and "Completed".

#include "datecl.h"
#include <assert.h>
void main()
{
			Date d1 = Date("01/15/93");
            d1.AddMonths(3);
            assert( d1 == Date("04/15/93"));

			 d1 = Date("01/15/93");
            d1.AddWeeks(3);
            assert( d1 == Date("02/05/93"));

    		 d1 = Date("01/15/93");
            d1.AddYears(3);
            assert( d1 == Date("01/15/96"));

            
             d1 = Date("07/04/93");
            Date d2 = d1.BOM();
            assert(d2 == Date("07/01/93"));

            
             d1 = Date("07/04/93");
             d2 = d1.BOY();
            assert(d2 == Date("01/01/93"));


              d1 = Date("09/01/1993");
            assert(strcmp(d1.CDOW(), "Wednesday") == 0);

             d1 = Date("09/01/1993");
            assert(strcmp(d1.CMonth(), "September")==0);

            
             d1 = Date("Today");
            d2 = d1 + 30;  // 30 days later.
            assert( d1 != d2);
            assert( d1 < d2);
            assert( d1<=d2);
            
            
            Date date1(10,30,1962);  // October 30, 1962
            Date date2(Date::OCTOBER, 30, 1962);     // same
            Date date3 = "8/8/88";   // August 9, 1988
            Date date4(2450000L);    // From a Julian
            Date date5(2,Date::SUNDAY,Date::MAY, 1993);
                                // 2nd Sunday in May
            
            d1="09/11/1993";
            assert(d1.Day() == 11);
            
            d1="09/11/1993";
            assert(d1.DaysInMonth() == 30);

            d1="02/15/1993";
            assert(d1.DOY() == 46);

            d1 = Date("07/04/93");
            d2 = d1.EOM();
            assert(d2 == Date("07/31/93"));
            
            d1="09/11/1993";
            DOSDATE_T  ddt;
            ddt = d1.eom();
            assert(ddt.day == 30);

            
            d1 = Date("07/04/93");
            d2 = d1.EOY();
            assert(d2 == Date("12/31/93"));

            
            d1="09/11/1993";
            assert(d1.FirstDOM() == Date::WEDNESDAY);

            

            d1="09/11/1993";
            const char *p = d1.formatDate(Date::FULL);
            assert(strcmp(p, "Saturday, September 11, 1993")==0);
            p = d1.formatDate(Date::COLLATE);
            assert(strcmp(p, "19930911")==0);
            Date::setFormat(Date::EUROPEAN);
            p = d1.formatDate();
            assert(strcmp(p, "11 September 1993")==0);

            
            
            d1="09/11/1993";
            ddt = d1.getDate();
            assert(ddt.day == 11);

            
            
            Date d = Date::PresidentsDay(1993);
            assert(d == Date("02/15/1993"));
            
            
            d="09/11/1993";
            assert(d.isLeapYear() == false);

            d.Set(Date::JULY, 4, 1993);
			assert(d.julDate() == 2449172L);

            
            
            d=Date(Date::SEPTEMBER, 11,1993);
            assert(d.NDOW() == 7);
            assert(d.NDOW() == Date::SATURDAY);

            d="09/11/1993";
            assert(d.NMonth() == 9);

            
            d1= "Today";
            assert( (d1.NYear4() >= 1993) && ( d1.NYear4() <=2000)  );

            
            d1="09/11/1993";
            Date::setFormat(Date::FULL);
            assert(strcmp(d1, "Saturday, September 11, 1993")==0);

            
            
            d1 = Date("08/15/1993");
            d2 = d1 + 13;  // 13 days later.
            assert( d2 == Date("08/28/1993"));


            d1 = Date("08/15/1993");
			d1 += 10; // 10 days later.
            assert( d1 == Date("08/25/1993"));
            assert( d1 < d2);
            assert( d1<=d2);


             d1="09/11/1993";
             d2="09/12/1993";
            assert( d1 ++ < d2);
            assert(d1 == d2);

			Date d3;
            d1.Set(); // Today's date.
            d2.Set(Date::JANUARY, 15, 1975);
            d3.Set(3, Date::SATURDAY, Date::JANUARY, 1987);
            
            
            Date::setCentury(1800);
             d1="9/11/93";
            assert(d1 == Date("09/11/1893"));

            d1="09/11/1993";
            Date::setFormat(Date::FULL);
            assert(strcmp(d1, "Saturday, September 11, 1993")==0);

            Date::setOption(Date::DATE_ABBR);
            Date::setFormat(Date::FULL);
            d1 = "9/11/1993";
            assert(strcmp(d1.formatDate(), "Sat, Sep 11, 1993")==0);
            Date::setOption(Date::NO_CENTURY,Date::ON);
            assert(strcmp(d1.formatDate(), "Sat, Sep 11, 93")==0);

            d1 = "09/12/1993";
            assert(d1.WOM() == 3);

            d1 = "02/15/1993";
            assert(d1.WOY() == 7);

            d1="Today";
			Date::setOption(Date::DATE_ABBR, Date::OFF);
			Date::setOption(Date::NO_CENTURY,Date::OFF);
			cout << "Today is " << Date::EUROPEAN << d1 << endl;

			cout << "a Date object is " << sizeof(d1) << " bytes long." <<endl;

            cout << " +++ Completed +++ " << endl;
            cout << " All Tests Passed " << endl;
}