/***************************************************************
*
*
*   ShareCom 1.0   
*    Copyright (C)  1994 Identity Software Inc
*
*
*   dk-util.h
*
*  Utility data structures
*/




#ifndef DKUTIL_H
#define DKUTIL_H

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef NULL
#define NULL 0
#endif


#ifndef GPF_T

#define GPF_T (* (long *)9 =0)

#endif


#define NEXT4(x) \
  ( (((x-1) >> 2) + 1) << 2)



/* 
  structs hash_elt and dk_hash 
  
  to implement a trivial hash table that will associate
   a number to a void * and efficiently retireve the
   item given the number
*/

typedef struct _hel {
  void * key;
  void *data;
  struct _hel *next;
} hash_elt_t;

typedef void (* maphash_func)(void* k, void* data);


typedef  void * (* rc_constr_t)(void * cdata);
typedef  void (* rc_destr_t)(void * item);


typedef struct _rc {
  long rc_fill;
  long rc_size;
  void ** rc_items;
  long rc_client_data;
  rc_constr_t rc_constructor;
  rc_destr_t rc_destructor;
  rc_destr_t rc_clear_func;
  /* Monitoring */
  long rc_gets;
  long rc_stores;
  long rc_peak_load;
} resource_t;




typedef struct dkhash {
  int                   (* ht_hash_func) ();
  int                   (* ht_cmp_func)();
  int                   ht_hash_size;
  hash_elt_t **         ht_elements;
} dk_hash_t;


#define NEW_VAR(type,var) \
  type *  var = (type *) dk_alloc(sizeof  (type))


/* prototypes */

void memcheck (long n);

void dk_exit (int n);
void dk_memory_initialize ();
void *dk_alloc (int c);
int dk_free (void * xx, long sz);
void * gethash (void * key, dk_hash_t *ht);
void * sethash (void * key, dk_hash_t *ht, void *data);
int remhash (void * key, dk_hash_t *ht);
dk_hash_t * hash_table_allocate (int size);
void maphash (maphash_func func, dk_hash_t *  table);
void clrhash (dk_hash_t *  table);
void hash_table_free (dk_hash_t * table);
void time_add (timeout_t *time1, timeout_t *time2);
int time_gt (timeout_t *time1, timeout_t *time2);


void get_real_time (timeout_t * time);
long get_msec_real_time ();


resource_t * resource_allocate (long sz, rc_constr_t constructor,
				rc_destr_t destructor, rc_destr_t clear_func,
				long client_data);


void * resource_get (resource_t * rc);
int resource_store (resource_t * rc, void * item);




#ifdef WINNT
#define fflush(x)
#endif

#define leave_and_return(semaphore,datatype,expression) \
	{datatype temp = expression;\
	semaphore_leave(semaphore); \
	return temp;}



#endif /* DKUTIL_H */


