#define IDM_ABOUT               100
#define IDM_SPEED               110

#define SIG_INSTALL             130
#define SIG_REMOVE              131

#define IDM_APP_SIG_INSTALL     140
#define IDM_APP_SIG_REMOVE      141

#define IDM_APP_ZERODIVIDE      150
#define IDM_APP_OVERFLOW        151
#define IDM_APP_UNDERFLOW       152
#define IDM_APP_INVALID         153

#define IDM_DLL_SIG_INSTALL         160
#define IDM_DLL_SIG_REMOVE          161
#define IDM_DLL_SIG_SAVE_RESTORE    162
#define IDM_DLL_SIG_NOSAVE_RESTORE  163

#define IDM_DLL_ZERODIVIDE      170
#define IDM_DLL_OVERFLOW        171
#define IDM_DLL_UNDERFLOW       172
#define IDM_DLL_INVALID         173

#define IDM_MASK_EXCEPTIONS     180
#define IDM_UNMASK_EXCEPTIONS   181

// Exception control setting:  method used to get/set FP control word
                                            
#define IDM_EC_FPMATH           190   // use __fpmath() function
#define IDM_EC_DIRECT           191   // directly program the 80x87 FCW
#define IDM_EC_CONTROL87        192   // use _control87() crt function

#define MATH_EMULATOR   0
#define MATH_ALTERNATE  1

// Functions defined in FLOATAPP.C ...

BOOL InitApplication(HINSTANCE);
BOOL InitInstance(HINSTANCE, UINT);
LRESULT CALLBACK MainWndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK About(HWND, UINT, WPARAM, LPARAM);

// Functions defined in FPSTUFF.C ...
DWORD TestFloatSpeed(UINT);
BOOL  FPStatus(UINT);
BOOL  FPMaskExceptions(BOOL);
BOOL  CheckCoprocessor(void);

// Functions defined in FPEXCEPT.C ...

BOOL  GenerateFPException(UINT);
BOOL  InstallSignalHandler(UINT);
