PAGE 58,132
;******************************************************************************
TITLE ISAPNP.ASM - Windows/386 Configuration Manager DLVxD ISA P&P
;******************************************************************************
;
;   (C) Copyright MICROSOFT Corp., 1993
;
;   Title:	ISAPNP.ASM - Windows/386 Config Manager DLVxD ISA P&P
;
;   Version:	1.00
;
;   Date:	21-Mar-1993
;
;   Author:	PYS
;
;------------------------------------------------------------------------------
;
;   Change log:
;
;      DATE	REV		    DESCRIPTION
;   ----------- --- -----------------------------------------------------------
;   21-Mar-1993 PYS Original
;
;==============================================================================

	.386p

;******************************************************************************
;				I N C L U D E S
;******************************************************************************

	.xlist
	include vmm.inc
	include debug.inc
	include configmg.inc
	include pnpdrvs.inc
	.list

;============================================================================
;		V I R T U A L   D E V I C E   D E C L A R A T I O N
;============================================================================

DECLARE_VIRTUAL_DEVICE	ISAPNP,PNPDRVS_Major_Ver,PNPDRVS_Minor_Ver,\
			ISAPNP_Control,51h,IOS_INIT_ORDER-1

VXD_REAL_INIT_SEG

STACK_SIZE	EQU	4096

BeginProc	ISAPNP_Real_Mode_Init

extrn		_IsolateRM	: NEAR

		xor	edx, edx

		test	bx, Duplicate_Device_ID
		jnz	RMErr

		cmp	ax, 400h
		jb	RMLoad

		mov	dx, ss
		shl	edx, 16
		mov	dx, sp

		mov	ax, ds
		mov	ss, ax
		mov	sp, offset rm_stack[STACK_SIZE]

		push	edx

		cCall	_IsolateRM, <ecx>

		mov	bx, sp
		lss	sp, dword ptr [bx]
		mov	edx, eax

RMLoad:
		mov	ax, Device_Load_Ok
		jmp	SHORT RMExit

RMErr:
		mov	ax, Abort_Device_Load + No_Fail_Message

RMExit:
		xor	bx, bx
		xor	si, si

		ret

EndProc		ISAPNP_Real_Mode_Init

BeginProc	_TimeToTicks

		push	bp
		mov	bp, sp
		mov	eax, [bp+4]
		mov	ecx, 1191380
		mul	ecx
		mov	ecx, 1000000
		div	ecx
		mov	dx, ax
		shr	eax, 16
		xchg	ax, dx
		leave
		ret

EndProc		_TimeToTicks

		ALIGN	2

rm_stack	db	(STACK_SIZE/8) DUP ('STACK~~~')

VXD_REAL_INIT_ENDS

VXD_LOCKED_CODE_SEG

;===========================================================================
;
;   PROCEDURE: ISAPNP_Control
;
;   DESCRIPTION:
;	Device control procedure for the ISAPNP DLVxD
;
;   ENTRY:
;	EAX = Control call ID
;
;   EXIT:
;	If carry clear then
;	    Successful
;	else
;	    Control call failed
;
;   USES:
;	EAX, EBX, ECX, EDX, ESI, EDI, Flags
;
;============================================================================

BeginProc ISAPNP_Control

	Control_Dispatch DEVICE_INIT, ISAPNP_Init, sCall, <edx>
	Control_Dispatch SYS_DYNAMIC_DEVICE_INIT, ISAPNP_Init, sCall, <edx>
	Control_Dispatch SYS_DYNAMIC_DEVICE_EXIT, ISAPNP_Exit, sCall, <edx, edi>
	Control_Dispatch PNP_NEW_DEVNODE, ISAPNP_NewDevNode, sCall, <ebx, edx>
	clc
	ret

EndProc	ISAPNP_Control

VXD_LOCKED_CODE_ENDS

	end
