#ifndef LONG64__H_
#define LONG64__H_

#include <iostream.h>

class long64
{
  public:
    unsigned long num[2];

   ~long64 () { }

    long64 () {num[0] = num[1] = 0L;}
    long64 ( const long64 &in) {num[0] = in.num[0]; num[1] = in.num[1];}
    long64 ( const long double in);
    long64 ( const long n0, const long n1 ) { num[0] = n0; num[1] = n1; }

    long double value(void);

    inline long64 operator- ( void ) const;
    inline long64 operator~ ( void ) const;
    inline long64 operator! ( void ) const;

    inline long64 operator++ ( void );   // prefix
    inline long64 operator-- ( void );   // prefix
    inline long64 operator++ ( int );    // postfix
    inline long64 operator-- ( int );    // postfix

    inline long64 operator+ ( const long64 &sec ) const;
    inline long64 operator- ( const long64 &sec ) const;
    inline long64 operator* ( const long64 &sec ) const;
    inline long64 operator/ ( const long64 &sec ) const;
    inline long64 operator% ( const long64 &sec ) const;
    inline long64 operator| ( const long64 &sec ) const;
    inline long64 operator& ( const long64 &sec ) const;

    inline long64 operator<< ( const int &shift ) const;
    inline long64 operator>> ( const int &shift ) const;

    inline long64 &operator=  ( const long64 &sec );

    inline long64 &operator+= ( const long64 &sec );
    inline long64 &operator-= ( const long64 &sec );
    inline long64 &operator*= ( const long64 &sec );
    inline long64 &operator/= ( const long64 &sec );
    inline long64 &operator%= ( const long64 &sec );
    inline long64 &operator|= ( const long64 &sec );
    inline long64 &operator&= ( const long64 &sec );

    inline long64 &operator<<= ( const int &shift );
    inline long64 &operator>>= ( const int &shift );

    inline int  operator<  ( const long64 &sec ) const;
    inline int  operator<= ( const long64 &sec ) const;
    inline int  operator>  ( const long64 &sec ) const;
    inline int  operator>= ( const long64 &sec ) const;
    inline int  operator== ( const long64 &sec ) const;
    inline int  operator!= ( const long64 &sec ) const;

    friend ostream& operator<< (ostream& os, long64& sec);
};

#endif
