// ------------------------------------------------------------------------
//
//   Create a class that creates a mapping from a word to a long
//
//   For explanation, see CMapWordToPtr in the Microsoft documentation
//
//		NOTICE THAT THIS CLASS MUST BE COMPILED LARGE MODEL !!!
//
//   Copyright 1993, Chris Shearer Cooper  CompuServe 76666,3026
//   This file may be copied and distributed free of charge as long as
//   this copyright notice remains intact and any changes by other
//   authors are clearly indicated.
//   This code may be used in your application without any monetary
//   royalty, however payment is required in the form of feedback and
//   bug reports to the author.  Although every effort has been made
//   to make this code bug-free, if you use this code in your application
//   the author takes no responsibility for any damages which may occur
//   from the operation of this code.
//
// ------------------------------------------------------------------------

#ifndef __MAP_WL_H


#define MAP_WL_BEFORE_START_POSITION ((void*)-1L)

class CMapWordToLong : public CMapWordToPtr
	{
	DECLARE_DYNAMIC(CMapWordToLong)
public:
// Construction
	__export CMapWordToLong(int nBlockSize=10);
	__export ~CMapWordToLong(void);

	// Lookup
	BOOL Lookup(WORD key, long &rValue) const
		{ return CMapWordToPtr::Lookup(key, (void *&)rValue); }

	// Lookup and add if not there
	long & operator[](WORD key)
		{ return (long &)CMapWordToPtr::operator[](key); }

	// add a new (key, value) pair
	void SetAt(WORD key, long newValue)
		{ CMapWordToPtr::SetAt(key, (void *)newValue); return; }

	POSITION GetStartPosition() const
		{ return (GetCount() == 0) ? NULL : MAP_WL_BEFORE_START_POSITION; }
	void __export GetNextAssoc(POSITION& pos, WORD& rKey, long &rValue) const;
	};
	

#define __MAP_WL_H
#endif


