
/***************************************************************
*
*
*   ShareCom 1.0   
*    Copyright (C)  1994 Identity Software Inc
*
* rpcapi.h
* 
*  External Data Representation
*
*/



void PrpcRegisterServiceDesc (service_desc_t * desc, 
               server_func f);

void PrpcRegisterService (char *name,
           server_func func,
           void* client_data,
           int ret_type,
           post_func postprocess); /* mty HUHTI was previously server_func */
                                   /* exact parameters needed for C++ parameter matching */


dk_thread_t * PrpcThreadAllocate (long sz);
void PrpcAddAnswer (caddr_t result, int ret_type);
io_action_func PrpcSetPartnerDeadHook (dk_session_t * ses, io_action_func f);

srv_req_hook_func PrpcSetServiceRequestHook(srv_req_hook_func  new_function)  ;
/* srv_req_hook_func  PrpcSetServiceRequestHook(sch_hook_func new_function); mty HUHTI */

sch_hook_func PrpcSetSchedulerHook(sch_hook_func new_function);

future_t * PrpcFuture (dk_session_t* server, service_desc_t* service, ...);
caddr_t PrpcValueOrWait (future_t* future);
caddr_t PrpcFutureNextResult (future_t* future);
dk_session_t * PrpcConnect (char * address, int sesclass);
dk_session_t * PrpcListen (char * addr, int sesclass);

void PrpcDisconnect(dk_session_t * session);
void PrpcDisconnectAll ();
void PrpcSessionFree (dk_session_t * ses);

void PrpcInitialize ();

void PrpcProtocolInitialize (int sesclass);

void PrpcSetThreadParams (long main, long server, long service,
                          int max_futures);
void PrpcFutureFree (future_t * future);
caddr_t PrpcSync (future_t * f);
future_t * PrpcFutureSetTimeout (future_t * future, long msecs);
long PrpcSetTimeoutResolution(long milliseconds);

unsigned long box_length (caddr_t box);

caddr_t dk_alloc_box (int bytes, int tag);
int dk_free_box (void* box);
int dk_free_tree (void* box);
int dk_free_box_and_numbers (void* box);
#ifdef OS2
unsigned long unbox (caddr_t n) ; /* mty 27.6.1992 */
#else
long unbox (caddr_t n);
#endif
caddr_t box_num (long n);
caddr_t box_string (char * string);
caddr_t box_double (double d);
caddr_t box_float (float d);

#define unbox_num(n) unbox(n)
#define unbox_float(f) (*((float *)f))
#define unbox_double(f) (*((double *)f))
#define unbox_string(s) ((char *)s)

dk_session_t * strses_allocate(void);
void strses_free (dk_session_t *ses);
long strses_length(dk_session_t * ses);
void strses_write_out(dk_session_t * out, dk_session_t * ses);
void strses_to_array (dk_session_t * ses, char * array);


void PrpcSetBackgroundAction (background_action_func f);


int PrpcWriteObject (dk_session_t * ses, caddr_t thing);

caddr_t PrpcReadObject (dk_session_t * ses);

void PrpcLeave ();

char * PrpcIAm (char * name);

dk_session_t * PrpcFindPeer (char * name);


int read_service_request (dk_session_t* ses);
