//
// $Id: NTDLLTST.HPP,v 1.2 1994/08/01 13:39:13 john Exp john $
//
// File name
// -------------
// NTDLLTST.HPP
//
//
// Written by John Spackman
// (c) Cavendish Software Limited, 1992-1994
//
//
// File Description
// ----------------
// Test Program for NewTrack v3.0/Windows; this part is intended to be
//	built for testing NewTrack when called from a DLL.
//
//
// Change Log
// ----------
// $Log: NTDLLTST.HPP,v $
// Revision 1.2  1994/08/01  13:39:13  john
// *** empty log message ***
//
// Revision 1.1  1994/06/10  11:38:16  john
// Initial revision
//
//
//


#ifndef __NTDLLTST_HPP
#define __NTDLLTST_HPP


#include <windows.h>


// PREPROCESSOR SYMBOL DEFINITIONS -- Import/Export
#if defined(_WIN32)
#   if defined(__NTDLLTST_CPP)
#       define _NTDLLTST_EXPORT_CLASS  __declspec(dllexport)
#       define _NTDLLTST_EXPORT_DATA   __declspec(dllexport)
#       define _NTDLLTST_EXPORT_FUNC   __declspec(dllexport)
#   else
#       define _NTDLLTST_EXPORT_CLASS  __declspec(dllimport)
#       define _NTDLLTST_EXPORT_DATA   __declspec(dllimport)
#       define _NTDLLTST_EXPORT_FUNC   __declspec(dllimport)
#   endif
#elif defined(__FLAT__)
#   if defined(__NTDLLTST_CPP)
#       define _NTDLLTST_EXPORT_CLASS  __export
#       define _NTDLLTST_EXPORT_DATA   __export
#       define _NTDLLTST_EXPORT_FUNC   __export
#   else
#       define _NTDLLTST_EXPORT_CLASS  __import
#       define _NTDLLTST_EXPORT_DATA   __import
#       define _NTDLLTST_EXPORT_FUNC   __import
#   endif
#else
#	if defined(__NTDLLTST_CPP) && (defined(__DLL__) || defined(_WINDLL))
#       define _NTDLLTST_EXPORT_CLASS  _export
#       define _NTDLLTST_EXPORT_DATA   _export
#       define _NTDLLTST_EXPORT_FUNC   _export
#   else
#       define _NTDLLTST_EXPORT_CLASS
#       define _NTDLLTST_EXPORT_DATA
#       define _NTDLLTST_EXPORT_FUNC
#	endif
#endif

#if defined(__BORLANDC__) || (defined(_MSC_VER) && !defined(_WIN32))
# define _NTDLLTST_EXPORT_CLASS_PTR(x)		* _NTDLLTST_EXPORT_CLASS x
# define _NTDLLTST_EXPORT_DATA_PTR(x)		* _NTDLLTST_EXPORT_DATA x
# define _NTDLLTST_EXPORT_FUNC_PTR(x)		* _NTDLLTST_EXPORT_FUNC x
#else
# define _NTDLLTST_EXPORT_CLASS_PTR(x)		_NTDLLTST_EXPORT_CLASS * x
# define _NTDLLTST_EXPORT_DATA_PTR(x)		_NTDLLTST_EXPORT_DATA * x
# define _NTDLLTST_EXPORT_FUNC_PTR(x)		_NTDLLTST_EXPORT_FUNC * x
#endif


// FUNCTION PROTOTYPES
#ifdef __cplusplus
extern "C"
{
#endif

char _NTDLLTST_EXPORT_FUNC_PTR(FAR PASCAL) NewTrackDLLTest(char *pPtrToDelete);

#if defined(STANDALONE_DLL_TEST)

// Initialises the Test DLL if we're using stand-alone NewTracks
void _NTDLLTST_EXPORT_FUNC FAR PASCAL NTDLLTST_Initialise(void);

// Terminates the Test DLL if we're using stand-alone NewTracks
void _NTDLLTST_EXPORT_FUNC FAR PASCAL NTDLLTST_Terminate(void);

#endif


#ifdef __cplusplus
};
#endif


#endif // __NTDLLTST_HPP
