// showprcn.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "showprcn.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CPrcntBar
IMPLEMENT_DYNCREATE(CPrcntBar, CWnd);

//
// Define statics
//
WNDPROC CPrcntBar::pfnSuperWndProc = NULL ;

//
//
//

CPrcntBar::CPrcntBar() 
	: bCreatedByClassName(FALSE) 
{ 
	m_nprcnt = 0; 
	black.CreateSolidBrush(RGB(0, 0, 0));	                                      
	blue.CreateSolidBrush(RGB(0, 0, 255));
	white.CreateSolidBrush(RGB(255, 255, 255));
}

LONG CALLBACK __export
CPrcntBar::FirstMsgOnlyWndProc(HWND hWnd, UINT msg, UINT wParam, LONG lParam)
{
	//
	// Construct the object and then attach the hWnd to it.
	//
	CPrcntBar * pBar = new CPrcntBar ;
	pBar->Attach(hWnd) ;
	
	pBar->bCreatedByClassName = TRUE ;
	
	//
	// Subclass the window by changing the window procedure to AfxWndProc
	// and pass the current message to it.
	//
	::SetWindowLong(hWnd, GWL_WNDPROC, (DWORD)AfxWndProc);

#ifdef STRICT
	return ::CallWindowProc((WNDPROC)AfxWndProc, hWnd, msg, wParam, lParam);
#else
	return ::CallWindowProc((FARPROC)AfxWndProc, hWnd, msg, wParam, lParam);
#endif
	//DER
}

//
// BOOL RegisterMyClass() ;
//
BOOL CPrcntBar::RegisterMyClass()
{
	WNDCLASS wcls ;
	
	if(!::GetClassInfo(NULL, "static", &wcls) )
	{
		return FALSE ;
	}

	if (pfnSuperWndProc == NULL) 
		pfnSuperWndProc = wcls.lpfnWndProc ;
	
	ASSERT( pfnSuperWndProc == wcls.lpfnWndProc) ;

	static const char szClassName[] = "prcntbar" ;
	if(::GetClassInfo(AfxGetInstanceHandle(), szClassName, &wcls))
	{
		return (wcls.lpfnWndProc == CPrcntBar::FirstMsgOnlyWndProc) ;
	}
	
	wcls.lpfnWndProc = CPrcntBar::FirstMsgOnlyWndProc ;
	wcls.hInstance = AfxGetInstanceHandle() ;
	wcls.lpszClassName = szClassName ;
	
	return (RegisterClass(&wcls) !=0) ;
}

//
// PostNcDestroy - delete the object we created on the heap. 
//
void CPrcntBar::PostNcDestroy()
{
	if( bCreatedByClassName )
		delete this;
}

BEGIN_MESSAGE_MAP(CPrcntBar, CWnd)
	//{{AFX_MSG_MAP(CPrcntBar)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrcntBar message handlers

void CPrcntBar::OnPaint()
{
	CPaintDC dc(this); // device context for painting
	CPaintDC *pDC = &dc;
	
	// TODO: Add your message handler code here
	CFont font;
	char szprcnt[10]; 

	sprintf(szprcnt, "%d%%", m_nprcnt);
	
	CRect frame;
	GetClientRect(&frame);
	                                      
	pDC->FrameRect(&frame, &black);
	
	frame.left += 1;
	frame.top += 1;
	frame.bottom -= 1;
	frame.right -= 1;

	pDC->FrameRect(&frame, &white);

	frame.left += 1;
	frame.top += 1;
	frame.bottom -= 1;
	frame.right -= 1;
	

	// Blue Rect with White Font	
	CRect rect(frame);
	rect.right = frame.left + frame.Width()*min(m_nprcnt, 100)/100;
	pDC->FillRect(&rect, &blue);      
    
	font.CreateFont(frame.Height()*4/5, 0, 0, 0, FW_SEMIBOLD, 0, 0, 0, ANSI_CHARSET, OUT_TT_PRECIS,
		CLIP_TT_ALWAYS,  DEFAULT_QUALITY, FF_SWISS, NULL);
	
	CFont *pOldFont = pDC->SelectObject(&font);
	
	pDC->SetTextAlign(TA_CENTER | TA_TOP);                                  
	pDC->SetTextColor(RGB(255,255,255));
	pDC->SetBkColor(RGB(0,0,255));
	pDC->ExtTextOut(frame.left + frame.Width()/2, 
			frame.Height()/5, 
			ETO_CLIPPED, 
			&rect, 
			szprcnt, 
			strlen(szprcnt), 
			NULL);
	
	// White Rect with blue font
	rect.left = rect.right+1;
	rect.right = frame.right;	
	if (rect.left < rect.right)
		pDC->FillRect(&rect, &white); 
	pDC->SetBkColor(RGB(255,255,255));
	pDC->SetTextColor(RGB(0,0,255));
	pDC->ExtTextOut(frame.left + frame.Width()/2, 
			frame.Height()/5, 
			ETO_CLIPPED, 
			&rect, 
			szprcnt, 
			strlen(szprcnt), 
			NULL);
			
	pDC->SelectObject(pOldFont);
	
	// Do not call CWnd::OnPaint() for painting messages
}

/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// CShowPrcnt dialog

CShowPrcnt::CShowPrcnt(CWnd* pParent /*=NULL*/, UINT nIDTemplate, UINT nIDBar)
	: CDialog(nIDTemplate, pParent)
{  
	//{{AFX_DATA_INIT(CShowPrcnt)
	//}}AFX_DATA_INIT                          
	CPrcntBar::RegisterMyClass();
	m_bCanceled = FALSE; 
	m_nprcnt = -1;
	m_nIDBar = nIDBar;
	m_prcntbar = NULL;
	Create(nIDTemplate, pParent);	// modeless
}

void CShowPrcnt::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CShowPrcnt)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CShowPrcnt, CDialog)
	//{{AFX_MSG_MAP(CShowPrcnt)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()                    

/////////////////////////////////////////////////////////////////////////////
// Operations
BOOL CShowPrcnt::OnInitDialog()
{ 
	CDialog::OnInitDialog(); 
                              
	if (m_nIDBar)                              
		m_prcntbar = (CPrcntBar *) GetDlgItem(m_nIDBar);  
		
	ASSERT(m_prcntbar->IsKindOf(RUNTIME_CLASS( CPrcntBar )));
	
	CenterWindow();
	
	return TRUE;
}

int CShowPrcnt::DoMessages()
{     
		
	while (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
    {   
        if (msg.message == WM_QUIT)
        {
           // bDoingBackgroundProcessing = FALSE;
           ::PostQuitMessage(0);
           break;
        }
        if (!AfxGetApp()->PreTranslateMessage(&msg))
        {
           ::TranslateMessage(&msg);
           ::DispatchMessage(&msg);
    	}
    }

    AfxGetApp()->OnIdle(0);   // updates user interface
    AfxGetApp()->OnIdle(1);   // frees temporary objects

	return 0;
}

BOOL CShowPrcnt::isAbbruch()
{ 
	return m_bCanceled; 
}   


void CShowPrcnt::SetPrcnt(int prcnt)
{                    
	if (m_nprcnt == prcnt)
		return;                           

	if (!m_prcntbar) 
		return;
		
	m_prcntbar->SetPrcnt(prcnt);
	m_prcntbar->Invalidate(TRUE);	
	m_prcntbar->UpdateWindow();
	
	m_nprcnt = prcnt;
}

void CShowPrcnt::SetStrText(UINT nIDC, const char *name)
{
	GetDlgItem(nIDC)->SetWindowText(name);
}

void CShowPrcnt::SetStrText(UINT nIDC, UINT nIDS)
{
	CString s;

	s.LoadString(nIDS);	
	GetDlgItem(nIDC)->SetWindowText(s);
}

/////////////////////////////////////////////////////////////////////////////
// CShowPrcnt message handlers

void CShowPrcnt::OnCancel()
{
	// TODO: Add extra cleanup here
	m_bCanceled = TRUE;
	TRACE("  !!!  CANCELED  !!! \n");
	
	CDialog::OnCancel();
}

void CShowPrcnt::OnClose()
{
	m_bCanceled = TRUE;
	TRACE("  !!!  CLOSED  !!! \n");
	
	CDialog::OnClose();
}

