//****************************************************************************
// File: SORTDEMO.H
//
// Purpose:
//
//     This include file provides global defines used by both the DLL and
//     the calling application. It also provides the class declaration for the
//     CSortdemoApp application object.
//
//
// Development Team:
//
//     Joel Krist
//
//
// Written by Microsoft Product Support Services, Languages Developer Support
// Copyright (c) 1993 Microsoft Corporation. All rights reserved.
//****************************************************************************

#ifndef __SORTDEMO_H__
#define __SORTDEMO_H__

#ifndef __AFXWIN_H__
    #error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"        // main symbols

// Global defines used by both the DLL and the calling executable
#define NUMSORTS    6    // The number of sort types
#define BUBBLE      0    // Numeric values used to represent the sort types
#define EXCHANGE    1
#define HEAP        2
#define INSERTION   3
#define QUICK       4
#define SHELL       5

#define SORTMASK   32    // Used when figuring out which sorts to start. This
                         // value needs to be 2 raised to the power of (NUMSORTS - 1).

#define CLEARTIME  -1    // Used when clearing elapsed times from previous sorts

/////////////////////////////////////////////////////////////////////////////
// CSortdemoApp:
// See sortdemo.cpp for the implementation of this class
//

class CSortdemoApp : public CWinApp
{
public:

// Overrides
    virtual BOOL InitInstance();
    virtual int ExitInstance();
};

#endif __SORTDEMO_H__
