#include "parse.h"



/*
 * AllocateData: Allocates memory for the data buffer, if not already
 * allocated. If allocated, then reallocates the buffer.  
 *
 * Returns: Pointer to the new Data
 */
BYTE *
AllocateData (ULONG BaseLen,int nAdd,BYTE *ptr)
{

	if (BaseLen > 0xffff) {
		LogPrintf ("Block too big in AllocateData\n");
		reset_cards();
		exit (-1);
	}
	
	if (!BaseLen) {
		if (!(ptr=malloc (nAdd))) {
			LogPrintf ("Malloc Failed in Allocated Data....Aborting\n");
			reset_cards();
			exit (-1);
		}
		memset (ptr,0,nAdd);
	}

	//Reallocate the Pointer
	else {
		if (!(ptr=realloc (ptr,nAdd+(UINT) BaseLen))) {
			LogPrintf ("Expand Failed in Allocated Data....Aborting\n");
			reset_cards();
			exit (-1);
		}
		memset (ptr+BaseLen,0,nAdd);
	}

	return (ptr);

}

//Reads a Word from the Read Config Data Port
BYTE 
ReadDataWord (void) 
{
		Out(ADR_PORT, ADR_RD_CFG_DATA);
		return (InData());
}



//Reset the cards on Exit
void
reset_cards (void) 
{

    Out(ADR_PORT, ADR_WAKE);
    Out(CMD_PORT, (BYTE)0);
}



int
LogPrintf(char *lpszFormat, ...)
{
	va_list			va;
	int 		nRet;
	char		    szBuffer[BUFSIZE];


	nLines+=HStrnOcc (lpszFormat,'\n');

	/* Prints the list to a buffer  */

	va_start(va, lpszFormat);
	nRet=vsprintf (szBuffer, lpszFormat, va);

	va_end(va);

	printf ("%s",szBuffer);

	if (nLines > nScreenHeight) {
		printf ("\nMore....");
		getch();
		printf ("\n");
		nLines=0;
	}
	return (nRet);
}
